package com.hai.dao;

import com.hai.entity.HighDiscountPackageDiscountActual;
import com.hai.entity.HighDiscountPackageDiscountActualExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighDiscountPackageDiscountActualMapper extends HighDiscountPackageDiscountActualMapperExt {
    @SelectProvider(type=HighDiscountPackageDiscountActualSqlProvider.class, method="countByExample")
    long countByExample(HighDiscountPackageDiscountActualExample example);

    @DeleteProvider(type=HighDiscountPackageDiscountActualSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighDiscountPackageDiscountActualExample example);

    @Delete({
        "delete from high_discount_package_discount_actual",
        "where id = #{id,jdbcType=INTEGER}"
    })
    int deleteByPrimaryKey(Integer id);

    @Insert({
        "insert into high_discount_package_discount_actual (agent_discount_code_id, discount_package_id, ",
        "discount_package_actual_id, agent_id, ",
        "discount_id, created_user_id, ",
        "created_time, `status`, ",
        "ext_1, ext_2, ext_3)",
        "values (#{agentDiscountCodeId,jdbcType=BIGINT}, #{discountPackageId,jdbcType=INTEGER}, ",
        "#{discountPackageActualId,jdbcType=INTEGER}, #{agentId,jdbcType=BIGINT}, ",
        "#{discountId,jdbcType=BIGINT}, #{createdUserId,jdbcType=INTEGER}, ",
        "#{createdTime,jdbcType=TIMESTAMP}, #{status,jdbcType=INTEGER}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighDiscountPackageDiscountActual record);

    @InsertProvider(type=HighDiscountPackageDiscountActualSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighDiscountPackageDiscountActual record);

    @SelectProvider(type=HighDiscountPackageDiscountActualSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.INTEGER, id=true),
        @Result(column="agent_discount_code_id", property="agentDiscountCodeId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_package_id", property="discountPackageId", jdbcType=JdbcType.INTEGER),
        @Result(column="discount_package_actual_id", property="discountPackageActualId", jdbcType=JdbcType.INTEGER),
        @Result(column="agent_id", property="agentId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_id", property="discountId", jdbcType=JdbcType.BIGINT),
        @Result(column="created_user_id", property="createdUserId", jdbcType=JdbcType.INTEGER),
        @Result(column="created_time", property="createdTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighDiscountPackageDiscountActual> selectByExample(HighDiscountPackageDiscountActualExample example);

    @Select({
        "select",
        "id, agent_discount_code_id, discount_package_id, discount_package_actual_id, ",
        "agent_id, discount_id, created_user_id, created_time, `status`, ext_1, ext_2, ",
        "ext_3",
        "from high_discount_package_discount_actual",
        "where id = #{id,jdbcType=INTEGER}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.INTEGER, id=true),
        @Result(column="agent_discount_code_id", property="agentDiscountCodeId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_package_id", property="discountPackageId", jdbcType=JdbcType.INTEGER),
        @Result(column="discount_package_actual_id", property="discountPackageActualId", jdbcType=JdbcType.INTEGER),
        @Result(column="agent_id", property="agentId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_id", property="discountId", jdbcType=JdbcType.BIGINT),
        @Result(column="created_user_id", property="createdUserId", jdbcType=JdbcType.INTEGER),
        @Result(column="created_time", property="createdTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighDiscountPackageDiscountActual selectByPrimaryKey(Integer id);

    @UpdateProvider(type=HighDiscountPackageDiscountActualSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighDiscountPackageDiscountActual record, @Param("example") HighDiscountPackageDiscountActualExample example);

    @UpdateProvider(type=HighDiscountPackageDiscountActualSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighDiscountPackageDiscountActual record, @Param("example") HighDiscountPackageDiscountActualExample example);

    @UpdateProvider(type=HighDiscountPackageDiscountActualSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighDiscountPackageDiscountActual record);

    @Update({
        "update high_discount_package_discount_actual",
        "set agent_discount_code_id = #{agentDiscountCodeId,jdbcType=BIGINT},",
          "discount_package_id = #{discountPackageId,jdbcType=INTEGER},",
          "discount_package_actual_id = #{discountPackageActualId,jdbcType=INTEGER},",
          "agent_id = #{agentId,jdbcType=BIGINT},",
          "discount_id = #{discountId,jdbcType=BIGINT},",
          "created_user_id = #{createdUserId,jdbcType=INTEGER},",
          "created_time = #{createdTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=INTEGER}"
    })
    int updateByPrimaryKey(HighDiscountPackageDiscountActual record);
}